unit FileU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, ToolEdit, ExtCtrls, Buttons;

type
  TZap = record
    Path1,Path2 : string;
    SubDir : boolean;
  end;
  TFileF = class(TForm)
    File1E: TFilenameEdit;
    Dir1E: TDirectoryEdit;
    DirB: TRadioButton;
    FileB: TRadioButton;
    Dir2E: TDirectoryEdit;
    SubDirB: TCheckBox;
    OkB: TBitBtn;
    CancelB: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FileBClick(Sender: TObject);
  private
    procedure Check;
  public
    function Execute(var Zap:TZap):boolean;
  end;

var
  FileF: TFileF;

function IsPath(const Path:string):boolean;

implementation


function IsPath(const Path:string):boolean;
begin
  Result:=Copy(Path,Length(Path),1)='\';
end;

{$R *.dfm}

procedure TFileF.FormShow(Sender: TObject);
begin
  Dir1E.Left:=File1E.Left;
  Dir1E.Top:=File1E.Top;
  Check;
end;

procedure TFileF.FileBClick(Sender: TObject);
begin
  Check;
end;

procedure TFileF.Check;
begin
  File1E.Visible:=FileB.Checked;
  Dir1E.Visible:=Not FileB.Checked;
  SubDirB.Visible:=Not FileB.Checked;
end;

function TFileF.Execute(var Zap: TZap): boolean;
begin
  FileB.Checked:=Copy(Zap.Path1,Length(Zap.Path1),1)<>'\';
  Dir1E.Text:=Zap.Path1;
  File1E.Text:=Zap.Path1;
  Dir2E.Text:=Zap.Path2;
  SubDirB.Checked:=Zap.SubDir;
  Result:=ShowModal=mrOk;
  if Not Result then
    Exit;
  if FileB.Checked then
    Zap.Path1:=File1E.DialogFiles.Text
  else
    Zap.Path1:=Dir1E.Text;
  if (FileB.Checked=False) and
     (Copy(Zap.Path1,Length(Zap.Path1),1)<>'\') then
    Zap.Path1:=Zap.Path1+'\';
  Zap.Path2:=Dir2E.Text;
  if Copy(Zap.Path2,Length(Zap.Path2),1)<>'\' then
    Zap.Path2:=Zap.Path2+'\';
  Zap.SubDir:=SubDirB.Checked;
end;

end.
