unit MainU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, FileU, Registry, ImgList, Buttons, ExtCtrls,
  NameU;

type
  TMainF = class(TForm)
    PageC: TPageControl;
    LogTab: TTabSheet;
    SetupTab: TTabSheet;
    SList: TListView;
    SAddFileB: TButton;
    SDelFileB: TButton;
    PList: TListView;
    Images: TImageList;
    TestB: TBitBtn;
    DoB: TBitBtn;
    StartTimer: TTimer;
    procedure SAddFileBClick(Sender: TObject);
    procedure SListCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure PageCChange(Sender: TObject);
    procedure PListDblClick(Sender: TObject);
    procedure TestBClick(Sender: TObject);
    procedure DoBClick(Sender: TObject);
    procedure SDelFileBClick(Sender: TObject);
    procedure StartTimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure RegSave;
    procedure RegLoad;
    procedure CheckPList;
    procedure GetFiles(const Path,Local:string;
              var ss:TStrings;const SubDir:boolean);
  end;

var
  MainF: TMainF;
  Project : string;
  Auto : boolean;

implementation

{$R *.dfm}

const
  RegKey = 'Software\RandySoft\Synchro';

procedure TMainF.SAddFileBClick(Sender: TObject);
var
  Zap : TZap;
  li : TListItem;
  ss : TStrings;
  i : integer;
begin
  Zap.Path1:='';
  Zap.Path2:='';
  Zap.SubDir:=False;
  if Not FileF.Execute(Zap) then
    Exit;
  ss:=TStringList.Create;
  ss.Text:=Zap.Path1;
  for i:=0 to ss.Count-1 do
  if ss[i]<>'' then
  begin
    li:=SList.Items.Add;
    li.Caption:=ss[i];
    li.SubItems.Add(Zap.Path2);
    if Zap.SubDir then
      li.SubItems.Add('')
    else
      li.SubItems.Add('');
    if IsPath(Zap.Path1)=False then
      li.SubItems[1]:='';
    SList.Selected:=li;
  end;
  ss.Free;
  SList.SetFocus;
  RegSave;
end;

procedure TMainF.SListCompare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
var
  s1,s2 : string;
begin
  s1:=Item1.Caption+#1+Item1.SubItems[0];
  s2:=Item2.Caption+#1+Item2.SubItems[0];
  if s1<s2 then
    Compare:=1
  else if s1>s2 then
    Compare:=-1
  else
    Compare:=0;
end;

procedure TMainF.RegLoad;
var
  s : string;
  r : TRegIniFile;
  ss : TStrings;
  i,j : integer;
  li : TListItem;
begin
  SList.Items.Clear;
  ss:=TStringList.Create;
  r:=TRegIniFile.Create;
  r.RootKey:=HKEY_LOCAL_MACHINE;
  r.ReadSection(RegKey+'\Path',ss);
  for j:=0 to ss.Count-1 do
  begin
    s:=r.ReadString(RegKey+'\'+Project,ss[j],'');
    if s<>'' then
    begin
      i:=Pos('!',s);
      if i<1 then
        i:=Length(s)+1;
      li:=SList.Items.Add;
      li.Caption:=Copy(s,1,i-1);
      s:=Copy(s,i+1,Length(s));

      i:=Pos('!',s);
      if i<1 then
        i:=Length(s)+1;
      li.SubItems.Add(Copy(s,1,i-1));
      s:=Copy(s,i+1,Length(s));

      li.SubItems.Add(s);
    end;
  end;
  ss.Free;
end;

procedure TMainF.RegSave;
var
  r : TRegIniFile;
  i : integer;
  s : string;
begin
  r:=TRegIniFile.Create;
  r.RootKey:=HKEY_LOCAL_MACHINE;
  r.EraseSection(RegKey+'\'+Project);
  r.CreateKey(RegKey+'\'+Project);
  for i:=0 to SList.Items.Count-1 do
  begin
    s:=SList.Items[i].Caption+'!'+SList.Items[i].SubItems[0]
      +'!'+SList.Items[i].SubItems[1];
    r.WriteString(RegKey+'\'+Project,IntToStr(i),s);
  end;
  r.Free;
end;

procedure TMainF.PageCChange(Sender: TObject);
begin
  if PageC.ActivePage=LogTab then
    CheckPList;
end;

procedure TMainF.PListDblClick(Sender: TObject);
begin
  if PList.Selected=nil then
    Exit;
  if PList.Selected.ImageIndex=0 then
    PList.Selected.ImageIndex:=1
  else if PList.Selected.ImageIndex=1 then
    PList.Selected.ImageIndex:=0;
end;

procedure TMainF.CheckPList;
label Skip;
var
  i,j,n : integer;
  li : TListItem;
  _Name : string;
  ss1,ss2 : TStrings;
  SubDir : boolean;
begin
  DoB.Enabled:=False;
  ss1:=TStringList.Create;
  ss2:=TStringList.Create;
  PList.Items.Clear;
  for i:=0 to SList.Items.Count-1 do
  begin
    _Name:=SList.Items[i].Caption;
    if IsPath(_Name) then
    begin
      ss1.Clear;
      ss2.Clear;
      SubDir:=SList.Items[i].SubItems[1]='';
      GetFiles(_Name,'',ss1,SubDir);
      GetFiles(SList.Items[i].SubItems[0],'',ss2,SubDir);
      for j:=0 to ss1.Count-1 do
      begin
        li:=Plist.Items.Add;
        li.Caption:='';
        li.ImageIndex:=0;
        li.SubItems.Add(_Name+ss1[j]);
        li.SubItems.Add('');
        li.SubItemImages[1]:=-1;
        li.SubItems.Add(SList.Items[i].SubItems[0]+ss1[j]);
        li.SubItems.Add('');
      end;
      for j:=0 to ss2.Count-1 do
      begin
        for n:=0 to ss1.Count-1 do
        if LowerCase(ss1[n])=LowerCase(ss2[j]) then
          goto Skip;
        li:=PList.Items.Add;
        li.Caption:='';
        li.ImageIndex:=0;
        li.SubItems.Add(_Name+ss2[j]);
        li.SubItems.Add('');
        li.SubItemImages[1]:=-1;
        li.SubItems.Add(SList.Items[i].SubItems[0]+ss2[j]);
        li.SubItems.Add('');
Skip:
      end;
    end else begin
      li:=PList.Items.Add;
      li.Caption:='';
      li.ImageIndex:=0;
      li.SubItems.Add(_Name);
      li.SubItems.Add('');
      li.SubItemImages[1]:=-1;
      li.SubItems.Add(SList.Items[i].SubItems[0]+ExtractFileName(_Name));
      li.SubItems.Add('');
    end;
    Application.ProcessMessages;
  end;
  ss1.Free;
  ss2.Free;
end;

procedure TMainF.GetFiles(const Path,Local: string; var ss: TStrings;
  const SubDir: boolean);
var
  sr : TSearchRec;
begin
  if FindFirst(Path+Local+'*.*',faAnyFile,sr)=0 then
  begin
    repeat
      Application.ProcessMessages;
      if (sr.Name<>'.') and (sr.Name<>'..') then
      begin
        if (sr.Attr and faDirectory)<>0 then
        begin
          if SubDir then
            GetFiles(Path,Local+sr.Name+'\',ss,SubDir);
        end else if (sr.Attr and (faHidden or faSysFile or
              faReadOnly or faVolumeId))=0 then
          ss.Add(Local+sr.Name);
        begin
        end;
      end;
    until FindNext(sr)<>0;
    FindClose(sr);
  end;
end;

procedure TMainF.TestBClick(Sender: TObject);
var
  i : integer;
  fn1,fn2 : string;
  fd1,fd2 : integer;
  li : TListItem;
  Was : boolean;
begin
  Was:=False;
  for i:=0 to PList.Items.Count-1 do
  begin
    li:=PList.Items[i];
    fn1:=li.SubItems[0];
    fn2:=li.SubItems[2];
    fd1:=FileAge(fn1);
    fd2:=FileAge(fn2);
    li.ImageIndex:=0;
    li.SubItemImages[1]:=-1;
    if (fd1=-1) and (fd2=-1) then       // 1-no 2 no
      li.SubItems[3]:='  '
    else if fd1=-1 then                 // 1-no 2-yes
    begin
      li.ImageIndex:=1;
      li.SubItemImages[1]:=3;
      Was:=True;
      li.SubItems[3]:='  I';
    end else if fd2=-1 then             // 1-yes 2-no
    begin
      li.ImageIndex:=1;
      li.SubItemImages[1]:=2;
      Was:=True;
      li.SubItems[3]:='  II';
    end else if fd1<fd2 then
    begin
      li.ImageIndex:=1;
      li.SubItemImages[1]:=3;
      Was:=True;
      li.SubItems[3]:=
         DateTimeToStr(FileDateToDateTime(fd1))
         +' < '+
         DateTimeToStr(FileDateToDateTime(fd2));
    end else if fd1>fd2 then begin
      li.ImageIndex:=1;
      li.SubItemImages[1]:=2;
      Was:=True;
      li.SubItems[3]:=
         DateTimeToStr(FileDateToDateTime(fd1))
         +' > '+
         DateTimeToStr(FileDateToDateTime(fd2));
    end else
      li.SubItems[3]:=' ';
  end;
  DoB.Enabled:=Was;
  if (Not Was) and (Not Auto) then
    Application.MessageBox('  .',' ',
         MB_ICONINFORMATION);
end;

procedure TMainF.DoBClick(Sender: TObject);
label Skip;
var
  s1,s2 : string;
  i : integer;
begin
  for i:=0 to PList.Items.Count-1 do
  if Plist.Items[i].ImageIndex=1 then
  begin
    if PList.Items[i].SubItemImages[1]=2 then
    begin
      s1:=Plist.Items[i].SubItems[0];
      s2:=Plist.Items[i].SubItems[2];
    end else if PList.Items[i].SubItemImages[1]=3 then begin
      s2:=Plist.Items[i].SubItems[0];
      s1:=Plist.Items[i].SubItems[2];
    end else
      goto Skip;
    ForceDirectories(ExtractFilePath(s1));
    ForceDirectories(ExtractFilePath(s2));
    if Not CopyFile(PChar(s1),PChar(s2),False) then
      PList.Items[i].SubItems[3]:=' ...'
    else begin
      FileSetDate(s2,FileAge(s1));
      PList.Items[i].SubItems[3]:='Ok'
    end;
Skip:
    Application.ProcessMessages;
  end;
//  CheckPList;
end;

procedure TMainF.SDelFileBClick(Sender: TObject);
begin
  if SList.Selected=nil then
    Exit;
  if Application.MessageBox('?','!',
        MB_YESNO+MB_ICONWARNING)<>ID_YES then
    Exit;
  SList.Selected.Delete;
  RegSave;
end;

var
  i : integer;

procedure TMainF.StartTimerTimer(Sender: TObject);
var
  ss : TStrings;
  r : TRegIniFile;
begin
  StartTimer.Enabled:=False;
  if Project='' then
  begin
    ss:=TStringList.Create;
    r:=TRegIniFile.Create;
    r.RootKey:=HKEY_LOCAL_MACHINE;
    r.OpenKey(RegKey,True);
    r.ReadSections(ss);
    r.CloseKey;
    r.Free;
    Project:=NameF.Execute(ss);
    ss.Free;
    if Project='' then
      Halt;
  end;
  RegLoad;
  PageC.ActivePage:=LogTab;
  CheckPList;
  if Auto then
  begin
    TestB.Click;
    Application.ProcessMessages;
    if DoB.Enabled then
    begin
      DoB.Click;
      Application.ProcessMessages;
    end;
  end;
end;

procedure TMainF.FormCreate(Sender: TObject);
begin
  StartTimer.Enabled:=True;
end;

initialization
  Auto:=False;
  Project:='';
  for i:=1 to ParamCount do
  begin
    if LowerCase(ParamStr(i))='/auto' then
      Auto:=True
    else
      Project:=ParamStr(i);
  end;

end.
